<?php

/*

Выводит список товаров для аякс-запросов

*/

if(!isset($_SERVER['HTTP_X_REQUESTED_WITH']) || strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) != 'xmlhttprequest'){
    exit;
}

if (!defined('MODX_API_MODE')) {
    define('MODX_API_MODE', false);
}

$tm_referer_id = isset($_POST['referer_id']) && !is_array($_POST['referer_id']) ? intval(trim($_POST['referer_id'])) : 1;
if(!$tm_referer_id) $tm_referer_id = 1;
$output = array('prod_list'=>'','pages'=>'','pageCount'=>1);

require_once '../../../config.core.php';
require_once MODX_CORE_PATH.'model/modx/modx.class.php';
$modx = new modX();

$criteria = $modx->newQuery('modResource');
$criteria->select(array($modx->escape('modResource').'.*'));
$criteria->where(array('id' => $tm_referer_id, 'deleted' => '0', 'published' => 1));
$modx->resource = $modx->getObject('modResource', $criteria);

if (!is_object($modx->resource) || !$modx->resource->checkPolicy('view')) {
    echo json_encode($output);
    exit;
}

$modx->resourceIdentifier = $modx->resource->get('id');
$modx->initialize($modx->resource->get('context_key'));
$modx->getService('error','error.modError');
$modx->getRequest();
$modx->getParser();
$modx->resourceMethod = 'id';

$modx->invokeEvent('OnLoadWebDocument');

require_once MODX_CORE_PATH."components/tag_manager/model/tag_manager.class.php";
$tag_mgr = new tag_manager($modx);

$tm_config = array(
    'numericTVs' => explode(',',str_replace(' ','',$modx->getOption('tag_mgr.numericTVs',null,''))),
    'catalog_id' => $modx->getOption('tag_mgr.catalog_id',null,1),
    'tpl' => $modx->getOption('tag_mgr.catalogItemTpl',null,''),
    'noResults' => $modx->getOption('tag_mgr.noResults',null,'<p class="no-result">Ничего не найдено.</p>'),
    'debug' => $modx->getOption('tag_mgr.debug',null,false),
    'parent_context' => $modx->getOption('tag_mgr.catalog_context',null,'web')
);
$output['prod_list'] = $tm_config['noResults'];

//Собираем пришедшие данные
$resources_ids = isset($_POST['docs']) && !is_array($_POST['docs']) ? trim($_POST['docs']) : '';
$display = isset($_POST['display']) && is_numeric($_POST['display']) ? trim($_POST['display']) : 0;
$page = isset($_POST['page']) && is_numeric($_POST['page']) ? trim(intval($_POST['page'])) : 1;
$sortby = isset($_POST['sortby']) && !is_array($_POST['sortby']) ? trim($_POST['sortby']) : 'pagetitle';
$sortdir = isset($_POST['sortdir']) && !is_array($_POST['sortdir']) ? trim($_POST['sortdir']) : 'asc';

//Проверяем чтобы все полученные ID находились внутри catalog_id
$parent_ids = explode(',',str_replace(' ','',$tm_config['catalog_id']));
$pchild_ids = array();

foreach($parent_ids as $parent_id){
    if($parent_id){
        $parent = $modx->getObject('modResource',$parent_id);
        $parent_context = $parent->get('context_key');
    }else{
        $parent_context = $tm_config['parent_context'];
    }
    $pchils = $modx->getChildIds(intval($parent_id),10,array('context' => $parent_context));
    $pchild_ids = array_merge($pchild_ids,$pchils);
}
$resources_ids_arr = explode(',',$resources_ids);

if($tm_config['debug']) var_dump('resources_id',$resources_ids,'pchild_ids',$pchild_ids);

$resources_ids_checked = array();
foreach($resources_ids_arr as $rid){
    if(in_array($rid,$pchild_ids)) array_push($resources_ids_checked,$rid);
}
unset($resources_ids,$resources_ids_arr,$pchild_ids);

if($tm_config['debug']) var_dump('resources_ids_checked',$resources_ids_checked);

//Берём параметры из набора параметров сниппета getPage
$properties = $tag_mgr->getPrepSetProperties('getPage');

if(!$display && isset($properties['limit'])) $display = $properties['limit'];

$prop_base = array();
if(count($resources_ids_checked)>0){
    //Формируем новые параметры снипета по полученным данным
    $prop_base = array(
        'resources' => implode(',',$resources_ids_checked),
        'parents' => -1
        //'debug' => true
    );
}

$prop_base['limit'] = $display;

if(in_array($sortby,array('pagetitle','longtitle','menuindex','pub_date','parent','createdon','publishedon'))){
    $prop_base['sortby'] = $sortby;
    $prop_base['sortdir'] = $sortdir;
}else{
    $sortby_tv = $modx->getObject('modTemplateVar',array('name'=>$sortby));
    if(is_object($sortby_tv)){
        $prop_base['sortby'] = '';
        $prop_base['sortdir'] = '';
        $prop_base['sortbyTV'] = $sortby;
        $prop_base['sortdirTV'] = $sortdir;
        $prop_base['sortbyTVType'] = in_array($sortby_tv->get('id'),$tm_config['numericTVs']) ? 'integer' : 'string';
    }
}

$properties = array_merge($properties,$prop_base);
if($tm_config['debug']) print_r($properties);

$out_html = $modx->runSnippet('getPage',$properties).'<div class="clear"></div>';
$out_html = $tag_mgr->stripModxTags($out_html);

$output['prod_list'] = $out_html;

if(isset($modx->placeholders[$properties['pageNavVar']])) $output['pages'] = $tag_mgr->stripModxTags($modx->placeholders[$properties['pageNavVar']]);
if(isset($modx->placeholders['pageCount'])) $output['pageCount'] = $modx->placeholders['pageCount'];

echo json_encode($output);

?>