<?php
/*

tm_hide_tvs

event: OnDocFormPrerender

Плагин скрывает TV, которые не отмечены в tagManager

*/

if($modx->context->get('key') != 'mgr') return;

$output = '';

$res_id = isset($_GET['id']) ? $_GET['id'] : 1;

$resource = $modx->getObject('modResource',$res_id);

$parent_ids = $modx->getParentIds($res_id,10,array('context'=>$resource->get('context_key')));
array_pop($parent_ids);

if(!empty($parent_ids)){
    
    $modx->addPackage('tag_manager', $modx->getOption('core_path').'components/tag_manager/model/');
    
    $query = $modx->newQuery('tagManager');
    $query->where(array('category:IN'=>$parent_ids));
    $tags = $modx->getCollection('tagManager',$query);
    
    $hidden_tvs_arr = array();
    
    foreach($tags as $tag){
        var_dump($tag->get('category'));
        if($tag->get('active') == 0 && !in_array($tag->get('tvid'),$hidden_tvs_arr)){
            array_push($hidden_tvs_arr,$tag->get('tvid'));
        }
    }
    
    //Формируем скрипт для скрытия TV
    foreach($hidden_tvs_arr as $tv_id){
        
        $output .= "
        if(Ext.get('tv{$tv_id}-tr') != null) Ext.get('tv{$tv_id}-tr').setStyle({\"display\":\"none\"});
        ";
        
    }
    
}

if($output){
    
    $output = '
    <script type="text/javascript">
        Ext.onReady(function() {
            '.$output.'
        });
    </script>
    ';
    
}

$modx->event->output($output);