<?php

/*
    snippet catalogFilters
*/

$toPlaceholder = $modx->getOption('toPlaceholder',$scriptProperties,false);

//Настройки кэширования
if(!empty($scriptProperties['cache'])){
    
    if(empty($scriptProperties['cache'])) $scriptProperties['cache'] = true;
    if(empty($scriptProperties['cache_key'])) $scriptProperties['cache_key'] = $modx->getOption('cache_resource_key', null, 'resource');
    if(empty($scriptProperties['cache_checkURL'])) $scriptProperties['cache_checkURL'] = true;
    if(empty($scriptProperties['cacheId'])) $scriptProperties['cacheId'] = 'tmCache';
    if(empty($scriptProperties['cache_handler'])) $scriptProperties['cache_handler'] = $modx->getOption('cache_resource_handler', null, 'xPDOFileCache');
    if(empty($scriptProperties['cache_expires'])) $scriptProperties['cache_expires'] = 0;
    
    if($scriptProperties['cache_checkURL']){
        $scriptProperties['cachePageKey'] = $modx->resource->getCacheKey() . '/' . $scriptProperties['cacheId'] . md5(http_build_query($modx->request->getParameters()));
    }else{
        $scriptProperties['cachePageKey'] = $scriptProperties['cacheId'];
    }
    
    $scriptProperties['cacheOptions'] = array(
        xPDO::OPT_CACHE_KEY => $scriptProperties['cache_key'],
        xPDO::OPT_CACHE_HANDLER => $scriptProperties['cache_handler'],
        xPDO::OPT_CACHE_EXPIRES => $scriptProperties['cache_expires'],
    );
    
    $cached = $modx->cacheManager->get($scriptProperties['cachePageKey'], $scriptProperties['cacheOptions']);
    
    //Если есть в кэше, выводим его содержимое
    if(!empty($cached) && isset($cached['placeholders']) && isset($cached['output'])){
        
        $output = $cached['output'];
        $modx->setPlaceholders($cached['placeholders']);
        
        if($toPlaceholder){
            $modx->setPlaceholder($toPlaceholder,$output);
            $output = '';
        }
        
        return $output;
        
    }else{
        
        $cached = array();
        
    }
    
}

$checkPlaceholders = $modx->placeholders;

require_once MODX_CORE_PATH."components/tag_manager/model/tag_manager.class.php";
$tag_mgr = new tag_manager($modx, $scriptProperties);

//Берём параметры из набора параметров сниппета getPage
$tag_mgr->config['snippetProperties'] = $tag_mgr->getPrepSetProperties('getPage');

$output = $tag_mgr->getFiltersOutput();

//Кэшируем
if(!empty($scriptProperties['cache'])){
    
    $cached = array(
        'output' => $output,
        'placeholders' => array_diff_assoc($modx->placeholders, $checkPlaceholders)
    );
    unset($checkPlaceholders);
    
    $modx->cacheManager->set($scriptProperties['cachePageKey'], $cached, $scriptProperties['cache_expires'], $scriptProperties['cacheOptions']);
    
}

if($toPlaceholder){
    $modx->setPlaceholder($toPlaceholder,$output);
    $output = '';
}

return $output;
