<?php
/*

Вывод товаров в каталоге с фильтрацией

Пример чекбокса и ссылки для фильтрации:

<input type="checkbox" name="[[+name]]__[[+index]]" value="[[+value]]">

Пример строки фильтрации:

?sortby=price&sortdir=asc&f_parent[]=14&f_size[]=1&f_price[from]=21398&f_price[to]=35000

*/

if(isset($scriptProperties['mode']) && $scriptProperties['mode']=='search' && empty($_GET['search'])) return '';

require_once MODX_CORE_PATH."components/tag_manager/model/tag_manager.class.php";
$tag_mgr = new tag_manager($modx, $scriptProperties);

$output = '';

//Берём параметры из набора параметров сниппета getPage
$properties = $tag_mgr->getPrepSetProperties('getPage');
if(!isset($properties['sortby'])) $properties['sortby'] = 'menuindex';
if(!isset($properties['sortdir'])) $properties['sortdir'] = 'asc';
if(!empty($scriptProperties['limit']) && is_numeric($scriptProperties['limit'])) $properties['limit'] = $scriptProperties['limit'];

$pl_ids_name = $modx->getOption('pl_ids_name',$scriptProperties,'catalog_ids');
$noResults = $modx->getOption('noResults',$scriptProperties,'Ничего не найдено.');
$searchMinLength = $modx->getOption('searchMinLength',$scriptProperties,3);
$numericTVs = $modx->getOption('tag_mgr.numericTVs',null,'');
$numericTVs = $numericTVs ? explode(',',$numericTVs) : array();
$show = isset($_GET['show']) && !is_array($_GET['show']) ? urldecode(trim($_GET['show'])) : '';
$limit = isset($_GET['limit']) && !is_array($_GET['limit']) ? $_GET['limit'] : $properties['limit'];
$debug = isset($scriptProperties['debug']) ? $scriptProperties['debug'] : false;
$sortby = isset($_GET['sortby']) && !is_array($_GET['sortby']) ? trim($_GET['sortby']) : $properties['sortby'];
$sortdir = isset($_GET['sortdir']) && !is_array($_GET['sortdir']) ? trim($_GET['sortdir']) : $properties['sortdir'];
if(strtolower($sortdir)=='rand' || strtolower($sortby)=='rand') { $sortby = 'RAND()'; }

$is_resources = empty($properties['className']) || $properties['className']=='modResource';

//Вытаскиваем имена числовых TV
$numericTVs_names = array();
if(count($numericTVs)>0){
    $tvs = $modx->getCollection('modTemplateVar',array(
        'id:IN' => $numericTVs
    ));
    if($tvs){
        foreach($tvs as $tv){
            $numericTVs_names[] = $tv->get('name');
        }
    }
}

//Приводим строку фильтрации к нормальному виду
list($flt_arr,$parents) = $tag_mgr->getRequestParams();
if(!empty($flt_arr)){
    
    if($debug) $output .= '<pre>'.print_r($flt_arr,true).print_r($parents,true).'</pre>';
    
    //Поиск подстроки
    if(!empty($_GET['word']) && mb_strlen($_GET['word'],'UTF-8')>=$searchMinLength){
        $search_value = htmlspecialchars(rawurldecode(trim($_GET['word'])));
        $where_arr = !empty($properties['where']) ? $modx->fromJSON($properties['where']) : array();
        $where_arr['pagetitle:LIKE'] = "%{$search_value}%";
        $properties['where'] = $modx->toJSON($where_arr);
    }
    
    //Если нужно выводить не ресурсы MODX
    if(!$is_resources){
        $where_arr = !empty($properties['where']) ? $modx->fromJSON($properties['where']) : array();
        $where_arr = array_merge($where_arr,$flt_arr);
        $properties['where'] = $modx->toJSON($where_arr);
        $flt_arr = array();
    }
    
    if(count($flt_arr)>0) $properties['tvFilters'] = json_encode($flt_arr);
    if(count($parents)>0) $properties['parents'] = implode(',',$parents);
}

if($limit){
    $modx->setPlaceholder('page_limit',$limit);
    $properties['limit'] = $limit;
}

if(!$is_resources || in_array($sortby,array('id','pagetitle','longtitle','menuindex','pub_date','parent','createdon','publishedon','RAND()'))){
    $properties['sortby'] = $sortby;
    $properties['sortdir'] = $sortdir;
}else{
    $properties['sortby'] = '';
    $properties['sortdir'] = '';
    $properties['sortbyTV'] = $sortby;
    $properties['sortdirTV'] = $sortdir;
    $properties['sortbyTVType'] = in_array($sortby,$numericTVs_names) ? 'integer' : 'string';
}

if(empty($flt_arr) && isset($modx->placeholders[$pl_ids_name])){
    $properties['resources'] = $modx->placeholders[$pl_ids_name];
    $properties['parents'] = -1;
}

//echo '<pre>'.print_r($properties,true).'</pre>';

$output .= $modx->runSnippet('getPage',$properties);

return strlen($output)>0 ? $output : $noResults;