<?php

/**
 * Get a parents list
 *
 * @package tag_manager
 * @subpackage processors
 */

$modx->addPackage('tag_manager',$modx->getOption('core_path').'components/tag_manager/model/');
require_once MODX_CORE_PATH."components/tag_manager/model/tag_manager.class.php";
$tag_mgr = new tag_manager($modx, $scriptProperties);

$list = array();

//Конфигурация компонента
$tag_mgr_config = array();
foreach($modx->config as $key => $conf){
    if(substr($key,0,8)=='tag_mgr.') $tag_mgr_config[substr($key,8)] = $conf;
}
$tag_mgr_config['tvs_arr'] = explode(',',str_replace(' ','',$tag_mgr_config['tvs']));
$tag_mgr_config['template_arr'] = explode(',',str_replace(' ','',$tag_mgr_config['templates']));
$tag_mgr_config['category_templates_arr'] = explode(',',str_replace(' ','',$tag_mgr_config['category_templates']));

//Контейнер каталога
$category_id = intval($modx->getOption('category_id',$scriptProperties,0));
$top_parent_id = $category_id ? $category_id : $tag_mgr_config['catalog_id'];
$top_parent_id_arr = explode(',',str_replace(' ','',$top_parent_id));
if(count($top_parent_id_arr)==0) return array();

//Категории товаров
$query = $modx->newQuery('modResource');
$query->where(array('template:IN' => $tag_mgr_config['category_templates_arr']));
$query->where(array('context_key' => $tag_mgr_config['catalog_context']));
$query->sortBy('parent','ASC');
$query->sortBy('menuindex','ASC');
$query->select($modx->getSelectColumns('modResource','modResource','',array('id','parent','pagetitle')));
$recources = $modx->getCollection('modResource',$query);

$res_arr = array();
foreach($recources as $recource){
    $res_arr[$recource->get('parent')][$recource->get('id')] = $recource->toArray();
}

//Проверяем какие категории уже есть в БД tag_manager
$categories_id_arr = array();
$c_query = $modx->newQuery('tagManager');
$c_query->select($modx->getSelectColumns('tagManager','tagManager','',array('id','category')));
$c_query->groupby('category');
$c_recources = $modx->getCollection('tagManager',$c_query);
foreach($c_recources as $c_recource){
    array_push($categories_id_arr,$c_recource->get('category'));
}

$list = array();
foreach($top_parent_id_arr as $parent_id){
    if($parent_id){
        $catalog_parent = $modx->getObject('modResource',$parent_id);
        $catalog_parent_id = $catalog_parent->get('id');
        $catalog_parent_context = $catalog_parent->get('context_key');
    }else{
        $catalog_parent_id = $parent_id;
        $catalog_parent_context = $tag_mgr_config['catalog_context'];
    }
    $temp_list = $tag_mgr->getChildParents($catalog_parent_id,10,$catalog_parent_context,$res_arr,$categories_id_arr);//$modx->getChildIds($catalog_parent_id,10,array('context'=>$catalog_parent_context));
    $list = array_merge($list,$temp_list);
}

$list = array_merge(array(array('id' => '','name' => $modx->lexicon('tag_mgr.default'),'saved' => '')),$list);

$count = count($list);

return $this->outputArray($list,$count);
