<?php
/**
 * Save tree state
 *
 * @package tag_manager
 * @subpackage processors
 */

$modx->addPackage('tag_manager',$modx->getOption('core_path').'components/tag_manager/model/');
require_once MODX_CORE_PATH."components/tag_manager/model/tag_manager.class.php";
$tag_mgr = new tag_manager($modx, $scriptProperties);

$treeValues = $modx->getOption('data',$scriptProperties,'');
$category_id = intval($modx->getOption('category_id',$scriptProperties,0));
$update = false;

if($treeValues){
    
    $treeValues_arr = $modx->fromJSON($treeValues);
    
    foreach($treeValues_arr as $key => $val){
        
        $item = $modx->getObject('tagManager', array(
            //"tvid" => $val['id'],
            //"tvcaption" => $val['caption'],
            "tvname" => $val['name'],
            "category" => $category_id
        ));
        
        if(!$item){
            $item = $modx->newObject('tagManager');
            $item->set('tvid',$val['id']);
            $item->set('category',$category_id);
            $item->set('active',$val['active']);
        }
        
        $new_values = array(array(),array());
        
        foreach($val['values'] as $k => $v){
            
            if(!in_array($v['value'],$new_values[0]) && !empty($v['value'])){
                //array_push($new_values[0], (is_numeric(str_replace(',','.',$v['value'])) ? str_replace(',','.',strval($v['value'])) : $v['value']));
                array_push($new_values[0], $v['value']);
                array_push($new_values[1],intval($v['active']));
            }
            
        }
        
        $tv_arr = $val['active'] ? $new_values : array(array(),array());
        
        $item->set('tvcaption',$val['caption']);
        $item->set('index',$key);
        $item->set('active',intval($val['active']));
        $item->set('tags',$modx->toJSON($tv_arr));
        $item->save();
        
        if($val['active'] /*&& count($val_arr[0])==0*/){
            $update = true;
        }
        
    }
    
    //echo '<pre>'; print_r($treeValues_arr); echo '</pre>';
    
}

//Обновляем значения
if($update){
    //$template_arr = explode(',',str_replace(' ','',$this->modx->getOption('tag_mgr.templates',null,0)));
    //$tvsid_arr = explode(',',str_replace(' ','',$this->modx->getOption('tag_mgr.tvs',null,0)));
    //$tv_arr = $tag_mgr->updateTagsValues($category_id, $tv_arr, array('template_arr'=>$template_arr, 'tvsid_arr'=>$tvsid_arr, 'update_cache'=>1));
    //var_dump($tv_arr);
}

//Очистка кэша сайта
if($category_id){
    $top_parent = $modx->getObject('modResource',$category_id);
    $workingContext = $modx->getContext($top_parent->get('context_key'));
    $modx->cacheManager->refresh(array(
        'resource' => array('contexts' => array($workingContext->get('key'))),
    ));
}

return $modx->error->success('');
