
/**
 * Главная страница компонента
 *
 * @class tagMgr.grid.catalog
 * @extends MODx.FormPanel
 * @param {Object} config An object of options.
 * @xtype tag_mgr-panel-home
 */


tagMgr.page.Cmp = function(config) {
    config = config || {};
    Ext.applyIf(config,{
        formpanel: 'tag_mgr-panel-home'
        ,buttons: [{
            xtype: 'modx-combo'
            ,id: 'tag_mgr-parentlist-cmp'
            ,fields: ['id','name','saved']
            ,allowBlank: true
            ,editable: false
            ,validateOnBlur: false
            ,resizable: true
            ,lastRawValue: ''
            ,url: tagMgr.config.connector_url
            ,baseParams: {
                action: 'getParentsList'
            }
            ,emptyText: _('tag_mgr.default')
            ,width: 200
            ,listeners: {
                beforeselect: function(combo, record, index ){
                    
                }
                ,select: function(combo, record, index){
                    
                    this.setRawValue(this.getRawValue().replace(/&nbsp;/g,''));
                    var root = this;
                    
                    if(record.data.saved.length==0 && index>0){
                        
                        Ext.Msg.confirm(
                            _('warning')
                            ,_('tag_mgr.change_category_confirm')
                            ,function(act){
                                if(act == 'yes'){
                                    Ext.getCmp('tag_mgr_filters_tree-cmp').onChangeCategory(combo, record.data.id);
                                    root.lastRawValue = root.getRawValue();
                                }else{
                                    root.setRawValue(root.lastRawValue);
                                }
                            }
                        );
                        
                    }else{
                        Ext.getCmp('tag_mgr_filters_tree-cmp').onChangeCategory(combo, record.data.id);
                        root.lastRawValue = root.getRawValue();
                    }
                    
                }
                ,change: function(){this.setRawValue(this.getRawValue().replace(/&nbsp;/g,''));}
                ,blur: function(){this.setRawValue(this.getRawValue().replace(/&nbsp;/g,''));}
            }
            ,tpl: '<tpl for="."><div class="x-combo-list-item">{saved} {name}<tpl if="id"> ({id})</tpl></div></tpl>'
        }
        //,'-',{
        //    text: ''
        //    ,icon: tagMgr.config.assets_url+'/img/delete.png'
        //    ,tooltip: _('tag_mgr.clear_category')
        //    ,handler: function(){
        //        Ext.getCmp('tag_mgr_filters_tree-cmp').deleteCategory();
        //    }
        //}
        ,'-',{
            text: _('save')
            ,handler: function(){
                Ext.getCmp('tag_mgr_filters_tree-cmp').saveTreeState();
            }
        },'-',{
            text: _('tag_mgr.clear_cache')
            ,handler: function() {
                Ext.getCmp('tag_mgr_filters_tree-cmp').clearCache();
            }
        }]
        ,components: [{
            xtype: 'tag_mgr-panel-home'
        }]
    });
    tagMgr.page.Cmp.superclass.constructor.call(this,config);
};
Ext.extend(tagMgr.page.Cmp,MODx.Component);
Ext.reg('tag_mgr-cmp',tagMgr.page.Cmp);



tagMgr.panel.Home = function(config){
    config = config || {};
    Ext.apply(config,{
        id: 'tag_mgr-panel-home-cmp'
        ,forceLayout: true
        ,cls: 'container modx-formpanel'
        ,defaults: { collapsible: false ,autoHeight: true }
        ,layout: 'form'
        ,border: false
        ,header: false
        ,items: [{
            html: '<h2>'+_('tag_mgr.name')+'</h2>'
            ,border: false
            ,cls: 'modx-page-header'
        },{
            xtype: 'modx-tabs'
            ,id: 'tag_mgr-panel-home-tabs-cmp'
            ,bodyStyle: 'padding: 10px;'
            ,defaults: {border: false ,autoHeight: true}
            ,border: true
            ,tabPosition: 'top'
            ,activeTab: 0
            ,autoDestroy: true
            ,stateful: false
            ,stateId: 'tag_mgr-home-tabpanel'
            ,stateEvents: ['tabchange']
            ,getState:function() {
                return {activeTab:this.items.indexOf(this.getActiveTab())};
            }
            ,items: [{
                title: _('tag_mgr.name')
                ,xtype: 'tag_mgr-tree-panel'
                ,id: 'tag_mgr_filters_tree-cmp'
            }]
            ,listeners: {
                tabchange: function(root,tab){
                    
                }
            }
        }]
        ,listeners: {
            afterrender: function(panel){
                
            }
            
        }
    });
    
    tagMgr.panel.Home.superclass.constructor.call(this,config);
};
Ext.extend(tagMgr.panel.Home,MODx.FormPanel,{
    
});
Ext.reg('tag_mgr-panel-home',tagMgr.panel.Home);

