
/*

http://modx-shopkeeper.ru/

tagManager 1.3.8 beta1

<div class="filter_row">
    <input type="checkbox" id="[[+name]]__[[+index]]" name="[[+name]]__[[+index]]" value="[[+value]]" />
    <a class="label" href="[[+url]]?f_[[+name]]=[[+value]]">[[+value]]</a>
</div>

*/

//Настройки
//Если какой-то функционал не нужен, сделать значение параметра пустым
var filtersOptions = {
	'show_filters_count': true,//Выводить цифры количества товаров по каждому фильтру
	'filters_cont': '#filters',//Селектор контейнера блоков с фильтрами
	'filters_row': 'div.filter_row',//Селектор строки с отдельным фильтром
	'products_cont': '#products',//Селектор контейнера с выводом товаров
	'filter_slider': 'div.range-slider',//Селектор слайдеров (ползунок для числовых значений)
	'filter_slider_cont': 'div.filter_slider',//Селектор контейнера со слайдером
	'unactive_class': 'unactive',//CSS-класс неактивного фильтра
	'label_class': 'label',//CSS-класс лейбла (ссылки) чекбокса фильтра
	'ajax_loader': '/assets/components/tag_manager/img/ajax-loader.gif',//адрес картинки прелоадера
	'pages_cont1': '#pages',//Селектор контейнера с постраничной навигацией
	'pages_cont2': '',//Селектор второго контейнера с постраничной навигацией. Если нет, оставить пустым.
	'pageAnchor': '#pageAnchor',//Селектор ссылки-якоря, к которому будет переход после возвращения результата фильтрации
	'active_page_selector': '.current',//селектор номера текущей страницы внутри контейнера (pages_cont)
	'show_limit_select': '#showLimit',//Селектор селекта "Показывать по"
	'sorting_cont': '#sorting',//Селектор контейнера с ссылками сортировок
	'guard_key': '#',//Разделитель для значений
	'multitags': ['tag'],//Имена TV (массив), значения которых нужно искать по совпадению подстрок (LIKE '%...%')
	'sorting': ['pagetitle','asc'],//Сортировка по умолчанию
	'numericTV_names': ['price','weight'],//Имена TV с числовыми значениями. Если числовых нет сделать пустой массив - [];
	'slider_steps': [10,0.1],//Число единиц шага слайдера.
	'calculating': false,
	'sorting_dir_pl': ['<span>&uarr;</span>','<span>&darr;</span>'],//HTML-элементы, которые будут добавляться в ссылку сортировки при клике
	'default_onpage_limit': 4,//число товаров на странице по умолчанию
	'hash_action': true,//Функционал применения фильтров по строке hash браузера + работа истории (назад/вперед)
	'ajax_url': '/assets/components/tag_manager/connector_fe.php',//URL php-файла куда будут отправляться ajax-запросы
	'filter_active': window.location.hash.length > 3 ? 1 : 0,
	'catalog_page': 1,//Текущая страница (не менять)
	'keyCtrl': false,//Нажата ли клавиша Ctrl (не менять)
	'ctl_show_all': false,
	'cur_hash': window.location.hash.substr(1)
};

var flt_data = 
  { 
    "products": [],
    "parents": []
  }
var idsPrices = {'ids':[],'price':[]};

if(typeof(price_values)=='undefined') var price_values = [0,10];
var flt_timer, loader_timer;
var resource_id = 0;

$(document).bind('ready',function(){
	
    //влючение фильтрации
    $('input:checkbox, a.'+filtersOptions.label_class, filtersOptions.filters_cont).searchFilter();
    
    if(filtersOptions.filter_slider.length>0){
		
		$(filtersOptions.filter_slider).each(function(i){
			
			var this_slider = $(this);
			var flt_field_cont = $(this).next(filtersOptions.filter_slider_cont);
			var flt_min_field = $("input[type='text']:eq(0)",flt_field_cont);
			var flt_max_field = $("input[type='text']:eq(1)",flt_field_cont);
			
			$(this).slider({
				range: true,
				min: parseFloat(flt_min_field.val()),
				max: parseFloat(flt_max_field.val()),
				values: [ parseFloat(flt_min_field.val()), parseFloat(flt_max_field.val()) ],
				step: typeof(filtersOptions.slider_steps[i])!='undefined' ? filtersOptions.slider_steps[i] : filtersOptions.slider_steps[0],
				slide: function(event, ui){
					if(flt_field_cont.size()>0){
						flt_min_field.val(ui.values[0]);
						flt_max_field.val(ui.values[1]);
					}
				},
				stop: function(event, ui){
					var flt_field_cont = $(this).next(filtersOptions.filter_slider_cont);
					filtersOptions.catalog_page = 1;
					var handle_index = $('a.ui-state-focus',this).prevAll().size();
					if(handle_index) tm_filters.sliderFilter($((handle_index==1 ? flt_min_field : flt_max_field)).get(0));
				}
			});
			
			//Действие при вводе числа в поле слайдера цен
			$('#'+flt_min_field.attr('id')+','+'#'+flt_max_field.attr('id')).bind('keyup',function(){
				if($(this).val() != this_slider.slider("values",0) && $(this).val() != this_slider.slider("values",1)){
					$(this).val($(this).val().replace(/[^0-9+\-Ee.]/g, ''));
					tm_filters.sliderFilter(this);
					this_slider.slider("values",0,flt_min_field.val());
					this_slider.slider("values",1,flt_max_field.val());
				}
			});
			
		});
		
    }
    
    //Показывать по
    if(filtersOptions.show_limit_select.length>0){
		$(filtersOptions.show_limit_select)
		.change(function(){
			filtersOptions.catalog_page = 1;
			tm_filters.startFiltering(true,false,filtersOptions.calculating);
		});
    }
    
    //Ссылки сортировок
    if(filtersOptions.sorting_cont.length>0){
		$('a',filtersOptions.sorting_cont)
		.bind('click',function(){
			
			var temp_arr = $(this).attr('href').split(/\?sortby=|&sortby=|&sortdir=/);
			tm_filters.activateSortLink($(this),temp_arr[1],temp_arr[2]);
			
			filtersOptions.sorting[0] = temp_arr[1];
			filtersOptions.sorting[1] = temp_arr[2];
			filtersOptions.catalog_page = 1;
			
			tm_filters.startFiltering(true,false,filtersOptions.calculating);
			
			return false;
		});
    }
    
    idsPrices = tm_filters.getIdsStat();
    tm_filters.getHashFilters();
    tm_filters.ajaxPagesInit();
    
	//История браузера
	if(filtersOptions.hash_action && typeof($.history)!='undefined'){
		$.history.init(function(hash){
			if(hash !== "" && !tm_filters.is_hash_change) {
				if(filtersOptions.cur_hash !== hash){
					filtersOptions.cur_hash = hash;
					tm_filters.getHashFilters();
					tm_filters.startFiltering(true,true,filtersOptions.calculating);
				}
			}
		});
	}
	
});


$(window).bind('load',function(){
    if(window.location.hash.length>=3){
		tm_filters.startFiltering(true,true);
    }else{
		tm_filters.startFiltering(false);
    }
});


$.fn.searchFilter = function(option){
    $(this).each(function(i){
		
		$(this).bind('click',function(e){
			
			filtersOptions.filter_active++;
			
			var flt = $(this).is('a') ? $(this).prev('input') : $(this);
			var parent = $(this).parent('div');
			clearTimeout(flt_timer);
			
			//лейбл
			if($(this).is('a')){
				
				//активный фильтр
				if(flt.is(':checked')){
					//alert(parent.is('.groupper'));
					if(!flt.is(':disabled')){
					  flt.removeAttr('checked');
					  $(this).removeClass('active');
					}
				//НЕактивный фильтр
				}else{
					if(!flt.is(':disabled')){
					  flt.attr('checked','checked');
					  $(this).addClass('active');
					}
				}
				
			//чекбокс
			}else{
			  
				//flt.attr('checked','checked');
			  
			}
			
			if(!flt.is(':disabled')){
				
				//flt_timer = setTimeout(startFiltering,1000);
				filtersOptions.catalog_page = 1;
				tm_filters.startFiltering(true,true,filtersOptions.calculating);
				
			}
			if($(this).is('a')) return false;
			
		});
      
    });
}


////////////////////////////////////////////

var tm_filters = {

is_hash_change: false,

is_array: function(input){
  return typeof(input)=='object'&&(input instanceof Array);
},

obj_clone: function(obj){
  if(obj == null || typeof(obj) != 'object') return obj;
  var temp = new obj.constructor(); 
  for(var key in obj) temp[key] = this.obj_clone(obj[key]);
  return temp;
},

array_max: function(obj) {
  var max = obj[0];
  var len = obj.length;
  for (var i = 1; i < len; i++) if (obj[i] > max) max = obj[i];
  return max;
},

array_min: function(obj) {
  var min = obj[0];
  var len = obj.length;
  for (var i = 1; i < len; i++) if (obj[i] < min) min = obj[i];
  return min;
},

array_intersect: function(){
    var arr1 = arguments[0], retArr = [];
    var k1 = '', arr = {}, i = 0, k = '';
    arr1keys: for (k1 in arr1) {
        arrs: for (i = 1; i < arguments.length; i++) {
            arr = arguments[i];
            for (k in arr) {
                if (arr[k] === arr1[k1]) {
                    if (i === arguments.length - 1) {
                        //retArr[k1] = arr1[k1];
                        retArr.push(arr1[k1]);
                    }
                    continue arrs;
                }
            }
            continue arr1keys;
        }
    }
    return retArr;
},


closestTo: function(number, set) {
    var closest = set[0];
    var prev = Math.abs(set[0] - number);
    for (var i = 1; i < set.length; i++) {
        var diff = Math.abs(set[i] - number);
        if (diff < prev) {
            prev = diff;
            closest = set[i];
        }
    }
    return closest;
},


replaceArray: function(replaceString, find, replace) {
  for (var i = 0; i < find.length; i++) {
    replaceString = replaceString.replace(find[i], replace[i]);
  }
  return replaceString;
},


updateArray: function(id,id_array){
    var r_index = $.inArray(id,id_array);
    if(r_index!=-1) id_array.splice(r_index,1);
    return id_array;
},


//Формирует массив ID и цен товаров
getIdsStat: function(){
    var output = {'ids':[],'price':[]};
    for(var i in flt_data.products){
		output.ids.push(parseInt(flt_data.products[i].id));
		for(var ii in filtersOptions.numericTV_names){
			var flt_name = filtersOptions.numericTV_names[ii];
			if(typeof(output[flt_name])=='undefined'){
				output[flt_name] = [];
			}
			if(typeof(flt_data.products[i][flt_name])!='undefined') output[flt_name].push(parseFloat(flt_data.products[i][flt_name]));
		}
    }
    return output;
},


randomProductsArray: function(object){
    var output = {'ids':[],'price':[],'width':[]};
    var index_arr = [];
    for(var i=0;i<object.ids.length;i++){
		index_arr.push(i);
    }
    index_arr.sort(function() {return 0.5 - Math.random()});
    for(var i=0;i<index_arr.length;i++){
		var ind = index_arr[i];
		output.ids.push(object.ids[ind]);
		output.price.push(object.price[ind]);
		output.width.push(object.width[ind]);
    }
    return output;
},

//Прелоадер
ajaxPreload: function(target,action){
	if(action==true){
		clearTimeout(loader_timer);
		if($('#ajax_loader').size()==0) target.prepend('<div id="ajax_loader"></div>');
		target.css('position','relative');
		$('#ajax_loader')
		.css({
			'position': 'absolute',
			'left': 0,
			'top': 0,
			'z-index': '200',
			//'padding': '10px',
			//'margin': '-10px 0 0 -10px',
			'width': target.width()+'px',
			'height': target.height()+'px',
			'background': "url('"+filtersOptions.ajax_loader+"') center center no-repeat #fff",
			'opacity': 0.7
		});
		//target.css({'height':target.height()+'px','overflow':'hidden'});
	}else{
		$('#ajax_loader').remove();
	}
},

//Фильтрация по значениям слайдера (например пределы цен)
sliderFilter: function(field){
    
    if(typeof(field)=='undefined') return;
	
    filtersOptions.filter_active++;
    
    clearTimeout(flt_timer);
    flt_timer = setTimeout(function(){
		
		var field_name = $(field).attr('name');
		var flt_name_arr = field_name.split('_');
		var flt_name = flt_name_arr[0];
		var field_value = field_name && $(field).val()!='' ? parseFloat($(field).val()) : 0;
		var filters = tm_filters.readFilters();
		var field_one = $('#'+flt_name+'Min');
		var field_two = $('#'+flt_name+'Max');
		var this_slider = $('#'+'range_'+flt_name);
		
		//проверяем чтобы введенное значение было в нужных пределах
		if($(field).attr('id')==field_one.attr('id')){
			if(field_value < this_slider.slider("option",'min')){
				field_value = this_slider.slider("option",'min');
				field_one.val(field_value);
			}else if(field_value > this_slider.slider("option",'max')){
				field_value = this_slider.slider("option",'max');
				field_one.val(field_value);
			}
			//передвигаем слайдер в положение соответствующее введенному значению
			this_slider.slider("values",0,field_value);
		}
		else if($(field).attr('id')==field_two.attr('id')){
			if(field_value > this_slider.slider("option",'max')){
				field_value = this_slider.slider("option",'max');
				field_two.val(field_value);
			}else if(field_value < this_slider.slider("option",'min')){
				field_value = this_slider.slider("option",'min');
				field_two.val(field_value);
			}
			//передвигаем слайдер в положение соответствующее введенному значению
			this_slider.slider("values",1,field_value);
		}
		
		prodIds = tm_filters.searchProducts(filters);
		
		//если товаров не найдено, изменяем значение на ближайшее
		if(prodIds.length==0){
			if($(field).attr('id')==field_one.attr('id')) filters[flt_name].flt[0] = tm_filters.array_min(idsPrices[flt_name]);
			if($(field).attr('id')==field_two.attr('id')) filters[flt_name].flt[1] = tm_filters.array_max(idsPrices[flt_name]);
			prodIds = tm_filters.searchProducts(filters);
			var new_value = [];
			for(var i in idsPrices.ids){
				if($.inArray(idsPrices.ids[i],prodIds)>-1 && !isNaN(idsPrices.ids[i])){
					new_value.push(idsPrices[flt_name][i]);
				}
			}
			//console.log(new_value);
			if(new_value.length>0){
				if($(field).attr('id')==field_one.attr('id')){
					field_one.val(tm_filters.array_max(new_value));
					this_slider.slider("values",0,tm_filters.array_max(new_value));
				}else{
					field_two.val(tm_filters.array_min(new_value));
					this_slider.slider("values",1,tm_filters.array_min(new_value));
				}
			}
			//console.log(new_value);
		}
		
		tm_filters.startFiltering(true,false,filtersOptions.calculating);
		
    },500);
    
},

//Применение фильтрации
startFiltering: function(load_results,move,load_count){
    if(typeof(load_results)=='undefined') var load_results = true;
    if(typeof(move)=='undefined') var move = true;
	if(typeof(load_count)=='undefined') var load_count = true;
    var filters = tm_filters.readFilters();
    var prodIds = tm_filters.searchProducts(filters);
    
    if(load_results) tm_filters.ajaxPreload($(filtersOptions.products_cont),true);
	
    //ставим циферки рядом с фильтрами
	if(filtersOptions.show_filters_count){
		$('input[type=checkbox]',filtersOptions.filters_cont).each(function(i){
			var f_link = $(this).next('a');
			
			if(f_link.next('sup').size()==0) f_link.after('<sup></sup>');
			
			var f_count = f_link.next('sup');
			var def_flt_name = $(this).attr('name').split('__');
			var if_filter = tm_filters.searchProducts(filters,$(this),1);
			var if_filter_count = tm_filters.searchProducts(filters,$(this),2).length;
			var if_filter_count_text = if_filter.length>0 ? if_filter_count : 0;
			
			//if(load_count){
				f_count.html(($(this).is(':checked') ? '&nbsp;' : if_filter_count_text));
			//}else{
				//if(if_filter_count_text==0) f_count.html(if_filter_count_text);
			//}
			
			tm_filters.markUnactive(i,$(this).is(':checked') ? if_filter_count : if_filter.length,if_filter_count_text);
		});
	}
	
    //console.log(prodIds);
    
    if(load_results){
		tm_filters.ajaxRequest(prodIds);
		if(filtersOptions.hash_action) tm_filters.addLocationHash(filters,move);
    }
    
},


//Отмечает текущую сортировку
activateSortLink: function(link,sortby,sortdir,revers_dir){
    
    if(typeof(revers_dir)=='undefined') var revers_dir = true;
    $('a',filtersOptions.sorting_cont).removeClass('active');
    link.addClass('active');
    
    if(link.attr('href').indexOf('='+sortdir)>-1){
		link.attr('href',tm_filters.replaceArray(link.attr('href'),['=desc','=asc','=_desc'],['=_desc','=desc','=asc']));
    }
    
    if(filtersOptions.sorting_dir_pl[0].length>0){
		$('a',filtersOptions.sorting_cont)
		.each(function(){
			$(this).html($(this).html().replace(/<.+>/,''));
		});
		link.append((sortdir=='asc' ? filtersOptions.sorting_dir_pl[0] : filtersOptions.sorting_dir_pl[1]));
    }
    
},

//Отмечает неактивные фильтры и делает неактивными чекбоксы. И отменает неактивность.
markUnactive: function(index,action,count_text){
    var parent = $(filtersOptions.filters_row,filtersOptions.filters_cont).eq(index);
    var input = $('input',parent);
    //if(parent.is('.groupper')) return;
    if(action>0){
		parent.removeClass(filtersOptions.unactive_class);
		parent.removeClass('onlyactive');
		if(count_text==0) parent.addClass('onlyactive');
		input.removeAttr('disabled');
    }else{
		if(input.is(':checked')){
				parent.addClass(filtersOptions.unactive_class);
		}else{
			parent.addClass(filtersOptions.unactive_class);
			input.attr('disabled','disabled');
		}
    }
},

//Поиск товаров
searchProducts: function(filters,default_elem,type){
    if(typeof(type)=='undefined') var type = 1;
    var prodIds = typeof(idsPrices) != 'undefined' ? idsPrices.ids.concat() : [];
    var s_filters = tm_filters.obj_clone(filters);
    var is_color = false;
	
	//console.log(filters);
	
    //проверка
    if(typeof(default_elem)!='undefined'){
		
		var def_flt_name = $(default_elem).attr('name').split('__');
		//var def_flt_ind = $(default_elem).val().split('_');
		//var def_flt_index = def_flt_ind[1];
		var def_flt_value = $(default_elem).val(); //isNaN(def_flt_ind[0]) ? def_flt_ind[0] : parseInt(def_flt_ind[0]);
		var def_key = $.inArray(def_flt_value,s_filters[def_flt_name[0]].flt);
		
		if(def_key==-1){
			if(type == 1) s_filters[def_flt_name[0]].flt = [def_flt_value];
			else s_filters[def_flt_name[0]].flt.push(def_flt_value);
		}else{
			if(type == 1) s_filters[def_flt_name[0]].flt.splice(def_key, 1);
			else s_filters[def_flt_name[0]].flt = [def_flt_value];//s_filters[def_flt_name[0]].flt = [];
		}
		
		if(def_flt_name[0]=='color') is_color = true;
		
    }
    
    //фильтруем
    if(typeof(flt_data)!='undefined'){
		for(var i in s_filters){
	  
			for(var ii in flt_data.products){
				
				//если это дочерний товар (модификация) и их показ запрещен, сразу фильтруем и продолжаем идти по циклу
				/*
				if(type==2 && !is_color && !filtersOptions.ctl_show_all && $.inArray(flt_data.products[ii].id,flt_data.parents)==-1){
				prodIds = updateArray(flt_data.products[ii].id,prodIds);
				continue;
				}
				*/
				
				//console.log(flt_data.products[ii][i],s_filters[i]);
				//console.log(flt_data.products[ii][i].toString(),flt_data.products[ii][i].toString().length,flt_data.products[ii][i].length);
				
				if(s_filters[i].flt.length>0 && $.inArray(parseInt(flt_data.products[ii].id),prodIds)>-1){//((is_array(flt_data.products[ii][i]) && flt_data.products[ii][i].length>0)) && 
					if(/*flt_data.products[ii][i].toString().length>0 &&*/ typeof(flt_data.products[ii][i])=='undefined' || tm_filters.filterItems(flt_data.products[ii][i],s_filters[i].flt,s_filters[i].action)){
						prodIds = tm_filters.updateArray(parseInt(flt_data.products[ii].id),prodIds);
					}
				}
			}
		}
    }
    
    return prodIds;
},


//Читает фильтры и формирует массив значений
readFilters: function(){
    var flt = new Object;
    //читаем фильтры
    $('input[type=checkbox]',filtersOptions.filters_cont).not('.flt_skip').each(function(i){
        var flt_name = $(this).attr('name').split('__');
        var flt_ind = $(this).val().split('_');
        var flt_index = flt_ind[1];
        var flt_checked = $(this).is(':checked');
        if(typeof(flt[flt_name[0]])=='undefined'){
			flt[flt_name[0]] = {};
			flt[flt_name[0]].flt = [];
			flt[flt_name[0]].ind = [];
			flt[flt_name[0]].action = $.inArray(flt_name[0],filtersOptions.multitags)>-1 ? 4 : 1;
        }
        if(flt_checked){
			flt[flt_name[0]].ind.push(flt_name[1]);
			flt[flt_name[0]].flt.push(flt_ind[0]);
        }
    });
    
    //фильтры со слайдерами
	if(filtersOptions.filter_slider_cont.length>0){
		$(filtersOptions.filter_slider_cont,filtersOptions.filters_cont).each(function(){
			var flt_name_arr = $('input:text:eq(0)',this).attr('name').split('__');
			var flt_name = flt_name_arr[0];
			flt[flt_name] = {};
			flt[flt_name].flt = [parseFloat($('input:text:eq(0)',this).val()),parseFloat($('input:text:eq(1)',this).val())];
			flt[flt_name].action = 3;
		});
	}
	
    return flt;
},



//Поиск значения в массиве
filterItems: function(value,array,action){
    if(typeof(action)=='undefined') var action = 1;
    var output = false;
    if(tm_filters.is_array(value)){
		var check = 0;
		for(var i in value){
			if(!tm_filters.filterItems(value[i],array,action)){
				check++;
				break;
			}
		}
		return check==0;
    }
    switch(action){
		case 1:
			//console.log(value,array,$.inArray(value,array));
			if($.inArray(value, array)==-1) output = true;
		break;
		case 2:
			if($.inArray(value, array)>-1) output = true;
		break;
		case 3:
			value = parseFloat(value);
			if(value < array[0] || value > array[1]) output = true;
		break;
		case 4:
			var temp_match = 0;
			for(var i in array){
				if(value.toString().indexOf(filtersOptions.guard_key+array[i]+filtersOptions.guard_key)>-1){
					temp_match++;
					break;
				}
			}
			if(temp_match==0) output = true;
		break;
		break;
    }
    return output;
},


parseFilter: function(flt,elem){
    var flt_name = elem.attr('name').split('__');
    var flt_ind = elem.val().split('__');
    var flt_index = flt_index[1];
    if(typeof(flt[flt_name[0]])=='undefined'){
      flt[flt_name[0]] = {};
      flt[flt_name[0]].flt = [];
    }
    flt[flt_name[0]].flt.push(parseInt(flt_name[1]));
    flt[flt_name[0]].action = 1;
    return flt;
},

//Создаёт строку location.hash по значениям фильтров
addLocationHash: function(filters,move,return_hash){
    if(typeof(move)=='undefined') var move = true;
    if(typeof(return_hash)=='undefined') var return_hash = false;
    var f_hash = '';
    for(var i in filters){
		if(filters[i].flt.length>0){
			f_hash += 'f_'+i+'=';
			for(var ii in filters[i].flt){
				var str = typeof(filters[i].ind)!='undefined' ? filters[i].flt[ii] : filters[i].flt[ii];
				//var str = typeof() filters[i].flt[ii]+'&'+filters[i].ind[ii];
				f_hash += ii>0 ? '|'+str : str;
			}
			f_hash += '&';
		}
    }
    f_hash += 'page='+filtersOptions.catalog_page;
    
    //хеш сортировок
    if(filtersOptions.sorting_cont.length>0){
		var tm_sort_link = $('a.active',filtersOptions.sorting_cont);
		var temp_arr = tm_sort_link.attr('href').split(/\?sortby=|&sortby=|&sortdir=/);
		f_hash += '&sortby='+temp_arr[1]+'&sortdir='+(temp_arr[2]=='asc' ? 'desc' : 'asc');
    }
	
	if(move) $(filtersOptions.pageAnchor).attr('name',f_hash);
	
    $.browser.safari = $.browser.webkit && !window.chrome;
    if(!return_hash){
		tm_filters.is_hash_change = true;
		window.location.hash = $.browser.safari ? encodeURI(f_hash) : f_hash;
		setTimeout(function(){ tm_filters.is_hash_change = false; },100);
		return true;
	}else{
		return f_hash;
	}
},


//Переносит строку фильтрации location.hash на фильтры
getHashFilters: function(){
    var l_hash = decodeURI(window.location.hash);
    if(!l_hash) return;
    var hash_filters = l_hash.substr(1,l_hash.length).split('&');
	
	$('input:checkbox',filtersOptions.filters_cont).removeAttr('checked');//Сброс чекбоксов
	
    for(var i in hash_filters){
		if(!hash_filters[i]) continue;
		var hf_flt = hash_filters[i].split('=');
		var hf_vals = hf_flt[1].split('|');
		if($.inArray(hf_flt[0].substr(2),filtersOptions.numericTV_names) > -1){
			if(hf_vals.length==2){
				var price1 = hf_vals[0];
				var price2 = hf_vals[1];
				$('#'+hf_flt[0]+'Min').val(price1);
				$('#'+'range_'+hf_flt[0]).slider("values",0,price1);
				$('#'+hf_flt[0]+'Max').val(price2);
				$('#'+'range_'+hf_flt[0]).slider("values",1,price2);
			}
		}else if(hf_flt[0]=='page'){
			filtersOptions.catalog_page = hf_flt.length>1 ? hf_flt[1] : 1;
		}else if(hf_flt[0]=='sortby' || hf_flt[0]=='sortdir'){
			if(hf_flt[0]=='sortby') filtersOptions.sorting[0] = hf_vals[0];
			if(hf_flt[0]=='sortdir') filtersOptions.sorting[1] = hf_vals[0];
		}else{
			for(var ii in hf_vals){
				var f_name = hf_vals[ii];
				var f_input = $('input[value="'+f_name+'"]:checkbox',filtersOptions.filters_cont);
				if(f_input.size()>0){
					f_input.each(function(){
						if($(this).attr('name').indexOf(hf_flt[0].substr(2))==0){
							$(this).attr('checked','checked');
							$(this).next('a').addClass('active');
						}
					});
				}
			}
		}
    }
    
    //Отмечаем текущую сортировку
    var temp_sort = $('a[href*="='+filtersOptions.sorting[0]+'"]',filtersOptions.sorting_cont);
    if(temp_sort.size()>0 && !temp_sort.is('.active')){
		tm_filters.activateSortLink(temp_sort,filtersOptions.sorting[0],filtersOptions.sorting[1]);
    }
    
    //startFiltering();
},

//Ajax-запросf
ajaxRequest: function(prodIds,params){
    if(typeof(params)=='undefined') var params = '';
    
    if(!params) params = 'ajax=1';
    
    if(params.indexOf('docs')==-1 && prodIds.length > 0)
		params += '&docs='+prodIds.join(',');
    else if(typeof(docId)!='undefined')
		params += '&parent='+docId;
  
    var onpage_limit = filtersOptions.show_limit_select.length>0 ? $(filtersOptions.show_limit_select).val() : filtersOptions.default_onpage_limit;
	
    params += '&display='+onpage_limit;
    params += '&page='+filtersOptions.catalog_page;
    params += '&referer_id='+resource_id;
    params += '&sortby='+filtersOptions.sorting[0]+'&sortdir='+filtersOptions.sorting[1];
    
    //если отмечен хотя бы один цвет, будем выводить товары с их цветами, иначе выводить будем только цвета по умолчанию.
    //if(filtersOptions.ctl_show_all) params += '&show_all=1';
    
    //console.log(filtersOptions.catalog_page);
    $.ajax({
		url: filtersOptions.ajax_url,
		type: "POST",//"GET",
		cache: false,
		data: params,
		dataType: 'json',
		success: function(response) {
			var prod_list = response.prod_list;
			$(filtersOptions.products_cont).html(prod_list);
			if(filtersOptions.pages_cont1.length>0) $(filtersOptions.pages_cont1).html(response.pages);
			if(filtersOptions.pages_cont2.length>0) $(filtersOptions.pages_cont2).html(response.pages);
			tm_filters.ajaxPreload($(filtersOptions.products_cont),false);
			if(typeof(initPage)=='function') initPage(response.pageCount,filtersOptions.catalog_page,onpage_limit);
		},
		error: function(jqXHR,textStatus,errorThrown){
			if(typeof(console)!='undefined') console.log(jqXHR,textStatus,errorThrown);
		}
    });
    
},


//Сброс всех фильтров
resetFilters: function(){
    $('input:checkbox',filtersOptions.filters_cont)
	.removeAttr('checked');
    $('a.'+filtersOptions.label_class,filtersOptions.filters_cont).removeClass('active');
	if(filtersOptions.filter_slider.length>0){
		$(filtersOptions.filter_slider).each(function(){
			var this_slider = $(this);
			var flt_field_cont = $(this).next(filtersOptions.filter_slider_cont);
			var flt_min_field = $("input[type='text']:eq(0)",flt_field_cont);
			var flt_max_field = $("input[type='text']:eq(1)",flt_field_cont);
			flt_min_field.val(this_slider.slider("option",'min'));
			this_slider.slider("values",0,this_slider.slider("option",'min'));
			flt_max_field.val(this_slider.slider("option",'max'));
			this_slider.slider("values",1,this_slider.slider("option",'max'));
		});
	}
    tm_filters.startFiltering(true,false);
},



displaySortSwitch: function(){
    var filters = tm_filters.readFilters();
    filtersOptions.catalog_page = 1;
    var flt_hash = tm_filters.addLocationHash(filters,false,true);
    window.location.href = window.location.pathname+'?ctl_display='+$('#ctl_display').val()+'&ctl_sortby_type=integer&ctl_sortby=price'+'#'+flt_hash;
},


//Инициализация ajax-перехода по страницам
ajaxPagesInit: function(){
    
	// переход по страницам при нажатии на клавиши "Ctrl + ->", "Ctrl + <-"
    $(document)
    .keydown(function(event){
		if(event.which==17) filtersOptions.keyCtrl = true;
    })
    .keyup(function(event){
		if(event.which==17) filtersOptions.keyCtrl = false;
		if($('#ajax_loader').size()>0) return; 
		if(filtersOptions.keyCtrl && event.which==37){
			var next_link = $(filtersOptions.active_page_selector, filtersOptions.pages_cont1).prev('a');
			if(next_link.size()==0) next_link = $(filtersOptions.active_page_selector, filtersOptions.pages_cont1).parent().prev().children('a');
			var next_page = next_link.size()>0 ? next_link.text() : 0;
		}
		if(filtersOptions.keyCtrl && event.which==39){
			var next_link = $(filtersOptions.active_page_selector, filtersOptions.pages_cont1).next('a');
			if(next_link.size()==0) next_link = $(filtersOptions.active_page_selector, filtersOptions.pages_cont1).parent().next().children('a');
			var next_page = next_link.size()>0 ? next_link.text() : 0;
		}
		if(next_page){
			filtersOptions.catalog_page = next_page;
			tm_filters.startFiltering(true,true,filtersOptions.calculating);
		}
    });
    
    if(filtersOptions.pages_cont1.length>0) tm_filters.ajaxPages(filtersOptions.pages_cont1);
    if(filtersOptions.pages_cont2.length>0) tm_filters.ajaxPages(filtersOptions.pages_cont2);
    
},

//Постраничная навигация
ajaxPages: function(parent){
	
	$(document).on('click', parent+' a', function(){
		var href = $(this).attr('href');
		var temp_arr = href.split('page=');
		var page = temp_arr.length>=2 ? temp_arr[1] : 1;
		
		filtersOptions.catalog_page = page;
		tm_filters.startFiltering(true,true,filtersOptions.calculating);
		
		return false;
	});
	
}


}
