
/*

http://modx-shopkeeper.ru/

*/

//Настройки
var filtersOptions = {
    'filters_cont': '#filters',//Селектор 
    'sortby': 'price',//Имя поля сортировки по умолчанию
    'sortdir': 'asc',//Направление сортировки по умолчанию
    'filter_mode': 'get' //hash | get
};

if (!Array.prototype.indexOf){
    Array.prototype.indexOf = function(elt /*, from*/)
    {
        var len = this.length;
        var from = Number(arguments[1]) || 0;
        from = (from < 0) ? Math.ceil(from) : Math.floor(from);
        if (from < 0) from += len;
        for (; from < len; from++){
            if (from in this && this[from] === elt)
                return from;
        }
        return -1;
    };
}

var tm_simple_filters = {

//Функция применяет строку фильтрации
submitFilters: function(filters,sorting,mode){
    if(filters==null) filters = [];
    if(sorting==null) sorting = [];
    clearTimeout(flt_timer);
    var filter_string = filtersOptions.filter_mode=='hash' ? window.location.hash.substr(1) : document.location.search.substr(1);
    filter_string = decodeURIComponent((filter_string + '').replace(/\+/g, '%20'));
    var f_str = '';
    var s_str = '';
    
    if(filter_string.length > 0){
        var filter_arr = filter_string.split('&');
        for(var i=0;i<filter_arr.length;i++){
            var flt_operator = '=';
            var temp_arr = filter_arr[i].split(flt_operator);
            if($.inArray(temp_arr[0],['sortby','sortdir']) == -1){
                if(i>0) f_str += '&';
                f_str += temp_arr[0]+'='+temp_arr[1];
            }
        }
    }
    
    if(sorting.length > 0){
        s_str = 'sortby='+sorting[0]+'&sortdir='+sorting[1];
    }
    
    //Добавляем строку поиска
    if($('input#search_word:text').size() > 0 && $('input#search_word:text').val().length > 0){
        s_str += (s_str.length>0 ? '&' : '') + $('#search_word').attr('name')+'='+$('#search_word').val();
    }
    
    flt_timer = setTimeout(function(){
        var hash_str = '';
        if(f_str.length>0) hash_str += f_str;
        if(s_str.length>0) hash_str += (hash_str.length>0 ? '&' : '') + s_str;
        if(mode=='hash'){
            window.location.hash = hash_str;
        }else{
            var current_url = window.location.pathname;
            window.location.href = hash_str.length>0 ? current_url+'?'+hash_str : current_url;
        }
    },1000);
},

//Инициализация сортировки
sortingInit: function(){
    
    $('select.f_sortby,select.f_sortdir').bind('change',tm_simple_filters.sortingAction);
    
},

//Действие при изменении параметров сортировки
sortingAction: function(event){
    
    var elem = event.currentTarget;
    
    var sortby =  filtersOptions.sortby;
    var sortdir = filtersOptions.sortdir;
    
    if ($('select.f_sortby').size() > 0) {
        sortby = $('select.f_sortby').val();
    }
    if ($('select.f_sortdir').size() > 0) {
        sortdir = $('select.f_sortdir').val();
    }
    
    tm_simple_filters.submitFilters(null,[sortby,sortdir],filtersOptions.filter_mode);
    
},

//Отмечает текущие фильтры и сортировки по параметрам в адресной строке
filterSelected: function(){
    
    var filter_string = filtersOptions.filter_mode=='hash' ? window.location.hash.substr(1) : document.location.search.substr(1);
    filter_string = decodeURIComponent((filter_string + '').replace(/\+/g, '%20'));
    var filter_arr = filter_string.split('&');
    
    for(var i=0;i<filter_arr.length;i++){
        var flt_operator = '=';
        var temp_arr = filter_arr[i].split(flt_operator);
        if(temp_arr.length>1){
            
            var select_sortby = $('select.f_sortby');
            var select_sortdir = $('select.f_sortdir');
            //sortby
            if(temp_arr[0]=='sortby' && select_sortby.size() > 0){
                select_sortby.val(temp_arr[1]);
                if(typeof(select_sortby.data("selectBoxIt"))!='undefined'){
                    select_sortby.data("selectBoxIt").refresh();
                }
            }
            //sortdir
            else if(temp_arr[0]=='sortdir' && select_sortdir.size() > 0){
                select_sortdir.val(temp_arr[1]);
                if(typeof(select_sortdir.data("selectBoxIt"))!='undefined'){
                    select_sortdir.data("selectBoxIt").refresh();
                }
            }else{
                
                var input = $('*[name="'+temp_arr[0]+'"]',filtersOptions.filters_cont);
                if (input.size() > 0){
                    
                    //checkbox
                    if(input.is(':checkbox')){
                        $('input[name="'+temp_arr[0]+'"][value="'+temp_arr[1]+'"]',filtersOptions.filters_cont).attr('checked','checked');
                    }
                    //select
                    else if(input.is('select')){
                        input.val(temp_arr[1]);
                        if(typeof(input.data("selectBoxIt"))!='undefined'){
                            input.data("selectBoxIt").refresh();
                        }
                    //text
                    }else if(input.is(':text')){
                        setTimeout(
                        (function(inp,v) {
                            return function() {
                                inp.val(v[1]);
                                //если есть слайдер
                                if($('div.ui-slider',inp.parent()).size() > 0){
                                    var slider_el = $('div.ui-slider',inp.parent());
                                    if(v[0].indexOf('[from]')>-1) slider_el.slider("values",0,v[1]);
                                    if(v[0].indexOf('[to]')>-1) slider_el.slider("values",1,v[1]);
                                }
                            }
                        })(input,temp_arr),200);
                    }
                    
                }
                
            }
            
        }
    }
    
}

}

var flt_timer;

var filters = {};

$(document).bind('ready',function(){
    
    //формируем объект данных текущих фильтров
    tm_simple_filters.filterSelected();
    
    //Назначаем действия на клик для чекбоксов фильтров
    /*
    $('input:checkbox',filtersOptions.filters_cont)
    .bind('click',function(){
        //Применяем фильтры
        tm_simple_filters.submitFilters(null,filtersOptions.filter_mode);
    });
    */
    
    //Сортировка
    tm_simple_filters.sortingInit();
    
});

